//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// This source code is licensed under Microsoft Shared Source License
// Version 1.0 for Windows CE.
// For a copy of the license visit http://go.microsoft.com/fwlink/?LinkId=3223.
//
#pragma once


//
// The following table provides a wide variety of RGBA color combinations.
//
// For the purposes of this table, D3DMVALUE is float
//
static CONST UINT uiNumSampleSingleColorValues = 33;
static CONST UINT uiNumSampleColorValues = 84;
static D3DMCOLORVALUE SampleColorValues[uiNumSampleColorValues] = {
//|          RED              |           GREEN           |            BLUE           |           ALPHA           |
//+---------------------------+---------------------------+---------------------------+---------------------------+
//|                           |                           |                           |                           |
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //*
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.1f) }, //**
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //***
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.3f) }, //****
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) }, //***** RED COLORS OF
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //***** VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) }, //*****
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.1f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.3f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) }, //***** GREEN COLORS OF
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //***** VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.1f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.3f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.4f) }, //***** BLUE COLORS OF
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //***** VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.6f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***** RED/GREEN COMBOS
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***** OF VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***** RED/BLUE COMBOS
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***** OF VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***** GREEN/BLUE COMBOS
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //***** OF VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.7f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.6f) , D3DM_MAKE_D3DMVALUE(0.4f) , D3DM_MAKE_D3DMVALUE(0.9f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.0f) , D3DM_MAKE_D3DMVALUE(0.8f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //*

  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //*
  { D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //**
  { D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.0f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.2f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //***** RED/GREEN/BLUE COMBOS
  { D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) }, //***** OF VARIOUS OPACITY
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.8f) }, //*****
  { D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //****
  { D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(1.0f) }, //***
  { D3DM_MAKE_D3DMVALUE(0.5f) , D3DM_MAKE_D3DMVALUE(0.2f) , D3DM_MAKE_D3DMVALUE(0.3f) , D3DM_MAKE_D3DMVALUE(1.0f) }  //**

};
